<template>
  <div class="app-warp">
    <div class="app-structure">
      <div class="app-search">
        <el-form ref="searchFrom" :model="searchFrom" label-width="60px">
          <el-row>
            <el-col :span="6">
              <el-form-item label="姓名" prop="NAME">
                <el-input v-model="searchFrom.NAME" placeholder="请输入姓名"/>
              </el-form-item>
            </el-col>
            <el-col :span="6">
              <el-form-item label-width="10px">
                <el-button v-waves type="primary" icon="el-icon-search" class="ml-10" @click="getQuery">
                  搜索
                </el-button>
                <el-button icon="el-icon-refresh" @click="goKeyReset">
                  重置
                </el-button>
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
      </div>
      <div class="app-tools">
        <div class="app-function">
          <el-button type="primary" icon="el-icon-plus" @click="fnAdd('','add')">新建</el-button>
        </div>
        <div class="app-minbtn">
          <span class="screening">
            <el-dropdown trigger="click">
              <el-button type="text" icon="el-icon-finished"/>
              <el-dropdown-menu slot="dropdown" style="margin-top:3px;">
                <div class="app-checkbox-group">
                  <el-checkbox-group v-model="checkList">
                    <el-checkbox v-for="item in checkboxList" :key="item" :label="item" style="display: block"/>
                  </el-checkbox-group>
                </div>
              </el-dropdown-menu>
            </el-dropdown>
          </span>
          <el-button type="text" icon="el-icon-refresh-left"/>
          <el-button type="text" icon="el-icon-full-screen"/>
        </div>
      </div>
      <div class="app-container">
        <el-table
          v-loading="listLoading"
          ref="multipleTable"
          :data="varList"
          :header-cell-style="{
            background:'#f5f7fa',
            'font-weight': 'bold',
            'color': '#000'
          }"
          tooltip-effect="dark"
          border
          fit
          highlight-current-row>
          <el-table-column type="index" label="序号" width="50" align="center"/>
          <el-table-column show-overflow-tooltip prop="NAME" label="姓名"/>
          <el-table-column
            v-if="checkList.includes('证件类型')"
            :show-overflow-tooltip="true"
            prop="CERTIFICATETYPE_NAME"
            label="证件类型"/>
          <el-table-column
            v-if="checkList.includes('证件编号')"
            :show-overflow-tooltip="true"
            prop="USER_ID_CARD"
            label="证件编号"/>
          <el-table-column
            v-if="checkList.includes('手机号')"
            :show-overflow-tooltip="true"
            prop="PHONE"
            label="手机号"/>
          <el-table-column
            v-if="checkList.includes('文化水平')"
            :show-overflow-tooltip="true"
            prop="CULTURAL_LEVEL_NAME"
            label="文化水平"/>
          <el-table-column label="操作" align="center" width="250">
            <template slot-scope="{row}">
              <el-button type="text" @click="fnResetPassword(row.USERNAME, row.USER_ID)">重置密码</el-button>
              <el-divider direction="vertical"/>
              <el-button type="text" @click="fnAdd(row.USER_ID,'edit')">编辑</el-button>
              <el-divider direction="vertical"/>
              <el-button type="text" @click="fnAdd(row.USER_ID,'view')">查看</el-button>
              <el-divider direction="vertical"/>
              <el-button type="text" @click="fnRecordList(row.USER_ID)">记录详情</el-button>
            </template>
          </el-table-column>
        </el-table>
        <div class="page-btn-group">
          <div/>
          <pagination :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList"/>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import Pagination from '@/components/Pagination' // 通过 el-pagination二次打包
import { requestFN } from '@/utils/request'
import waves from '@/directive/waves' // waves directive

export default {
  components: { Pagination },
  directives: { waves },
  data() {
    return {
      listLoading: true,
      listQuery: {
        page: 1,
        limit: 10
      },
      total: 0,
      varList: [],
      searchFrom: {
        NAME: ''
      },
      searchFromCollapse: true,
      checkList: ['证件类型', '证件编号', '手机号', '文化水平'],
      checkboxList: ['证件类型', '证件编号', '手机号', '文化水平']
    }
  },
  inject: ['setActiveName', 'setUserId', 'setType'],
  created() {
    this.listLoading = false
    this.getList()
  },
  methods: {
    getQuery() {
      this.$refs.multipleTable.clearSelection()
      this.getList()
    },
    goKeyReset() {
      this.$refs.searchFrom.resetFields()
      this.listQuery = {
        page: 1,
        limit: 10
      }
      this.getList()
    },
    getList() {
      requestFN(`/student/list?showCount=${this.listQuery.limit}&currentPage=${this.listQuery.page}`, {
        PERSONNELTYPE: '6',
        ...this.searchFrom
      }).then(data => {
        this.varList = data.list
        this.total = data.page.totalResult
        this.listLoading = false
      })
    },
    fnResetPassword(USERNAME, USER_ID) {
      this.$confirm('确认重置密码吗？', '提示', {
        type: 'warning'
      }).then(() => {
        requestFN('/student/initPass', {
          USER_ID,
          USERNAME
        }).then(data => {
          this.$message({
            type: 'success',
            message: '重置成功!'
          })
          this.goKeyReset()
        })
      }).catch()
    },
    fnAdd(USER_ID, TYPE) {
      this.setActiveName('Add')
      this.setUserId(USER_ID)
      this.setType(TYPE)
    },
    fnRecordList(USER_ID) {
      this.setActiveName('RecordList')
      this.setUserId(USER_ID)
    }
  }
}

</script>
<style>
</style>
